<template>
  <div
    class="row dropzone"
  >
    <div
      class="row justify-center items-center"
      style="width: 100%"
    >
      <div style="width: 100%; font-size: 20px; text-align: center">
        Overall Upload
      </div>
      <div style="height: 200px">
        <q-circular-progress
          show-value
          font-size="20px"
          :value="uploadProgress"
          size="150px"
          :thickness="0.25"
          color="black"
          track-color="grey-3"
          class="q-ma-md"
        >
          {{ uploadProgress }}%
        </q-circular-progress>
      </div>
      <div
        v-if="averageUploadSpeed>0"
        style="width: 100%; text-align: center; margin-top: -20px"
      >
        {{ averageUploadSpeed * 8 }} Mbit/s<br>
        {{ remainingTimeStr }} remaining
      </div>
      <div
        v-else
        style="width: 100%; text-align: center; margin-top: -20px"
      >
        Estimating upload speed<br>
        and remaining time
      </div>
      <div style="width: 100%; text-align: center">
      <q-btn
        class="q-ma-sm"
        outline
        :icon="getPauseOrResumeIcon()"
        @click="pauseOrResumeAllUploads()"
      >
        <q-tooltip
        anchor="top middle"
        self="bottom middle"
        :offset="[15, 15]">
          Pause or resume uploads
        </q-tooltip>
      </q-btn>

      <q-btn
        class="q-ma-sm"
        color="red"
        outline
        icon="cancel"
        @click="cancelAll()"
      >
        <q-tooltip
        anchor="top middle"
        self="bottom middle"
        :offset="[15, 15]">
          Cancel queued upload
        </q-tooltip>
      </q-btn>
      </div>
    </div>
  </div>
</template>

<script>
import { fileStatusIconMapping } from '../mixins/uploads'

export default {
  name: 'UploadProgress',
  props: {
    uploadManager: {
      type: Object,
      default: function () {
        return null
      }
    }
  },
  data: function () {
    return {
      fileStatusIconMapping: fileStatusIconMapping,
      uploadStats: [],
      totalMegaBytes: 0,
      uploadedMegaBytes: 0,
      uploadProgress: 0
    }
  },
  computed: {
    averageUploadSpeed: function () {
      let averageUploadSpeed = 0.0
      if (this.uploadStats.length > 1) {
        const uploadedMbDiff = (this.uploadStats[0].uploadedMegaBytes - this.uploadStats[this.uploadStats.length - 1].uploadedMegaBytes)
        const timeDiff = (this.uploadStats[0].time - this.uploadStats[this.uploadStats.length - 1].time)
        averageUploadSpeed = uploadedMbDiff / timeDiff
      }
      return Math.round(averageUploadSpeed * 1000.0 * 100.0) / 100.0
    },
    remainingTime: function () {
      const remainingMegaBytes = this.totalMegaBytes - this.uploadedMegaBytes
      if (this.averageUploadSpeed > 0) {
        return Math.round(remainingMegaBytes / this.averageUploadSpeed)
      } else {
        return 0
      }
    },
    remainingTimeStr: function () {
      if (this.remainingTime <= 60) {
        return this.remainingTime.toString() + ' s'
      }
      if (this.remainingTime > 60 && this.remainingTime <= 60 * 60) {
        const minutes = Math.floor(this.remainingTime / 60)
        const seconds = this.remainingTime - minutes * 60
        return `${minutes} min ${seconds} s`
      }
      if (this.remainingTime > 60 * 60 && this.remainingTime <= 60 * 60 * 24) {
        const hours = Math.floor(this.remainingTime / (60 * 60))
        const minutes = Math.round(this.remainingTime / 60 - hours * 60)
        return `${hours} h ${minutes} min`
      }
      if (this.remainingTime > 60 * 60 * 24) {
        const days = Math.floor(this.remainingTime / (60 * 60 * 24))
        const hours = Math.round(this.remainingTime / (60 * 60) - days * 24)
        return `${days} d ${hours} h`
      }
      return '-'
    }
  },
  watch: {
    uploadManager: {
      handler () {
        const uploadedBytes = this.uploadManager.getUploadedBytes()
        this.uploadProgress = Math.round(100 * this.uploadManager.getProgress())
        this.uploadedMegaBytes = Math.round(uploadedBytes / 1000000.0)
        this.totalMegaBytes = Math.round(this.uploadManager.getTotalBytesUploading() / 1000000.0)
        this.updateUploadStats(this.uploadedMegaBytes)
      },
      deep: true
    }
  },
  methods: {
    updateUploadStats (uploadedMegaBytes) {
      if (this.uploadStats.length > 1) {
        const latestElement = this.uploadStats[this.uploadStats.length - 1]
        const uploadedMbDiff = uploadedMegaBytes - latestElement.uploadedMegaBytes
        const timeDiff = (new Date()).getTime() - latestElement.time
        if (uploadedMbDiff < 0) {
          this.uploadStats = []
        }
        if (timeDiff > 1000) {
          this.uploadStats.push({ uploadedMegaBytes: uploadedMegaBytes, time: (new Date()).getTime() })
        }
        if (this.uploadStats.length > 5) this.uploadStats.shift()
      } else {
        this.uploadStats.push({ uploadedMegaBytes: uploadedMegaBytes, time: (new Date()).getTime() })
      }
    },
    pauseOrResumeAllUploads () {
      if (this.uploadManager.isUploading()) {
        this.uploadManager.pause()
      } else {
        this.uploadManager.resume()
      }
    },
    getPauseOrResumeIcon () {
      if (this.uploadManager) {
        if (this.uploadManager.isUploading()) {
          return this.fileStatusIconMapping.uploading
        } else {
          return this.fileStatusIconMapping.paused
        }
      }
    },
    cancelAll () {
      this.uploadManager.cancel()
    }
  }
}
</script>

<style scoped lang="scss">
.dropzone {
  width: 100%;
  height: 100%;
  position: relative;
}
.dropzoneBorder {
  border-style: dashed;
  border-width: thin;
  border-color: grey;
}
</style>
